ExtraSpellAlert = LibStub("AceAddon-3.0"):NewAddon("ExtraSpellAlert", "AceConsole-3.0", "AceEvent-3.0", "AceTimer-3.0", "AceHook-3.0");
local core = ExtraSpellAlert;
local L = LibStub("AceLocale-3.0"):GetLocale("ExtraSpellAlert")
local LSM; -- LibSharedMedia-3.0, checked later

local fontPaths = {
	["Friz Quadatra"] = "Fonts\\FRIZQT__.TTF",
	["Arial Narrow"] = "Fonts\\ARIALN.TTF",
	["Skurri"] = "Fonts\\skurri.ttf",
	["Morpheus"] = "Fonts\\MORPHEUS.ttf",
};
local overlayMap = {	-- some overalys proc off of weird ids, so this maps the id to its "correct" spell
	[79808] = 5143,
};
local defaults = {
	profile = {
		stacks = {
			enabled = true,
		},
		warn = {
			enabled = true,
			thresh = 5,
			color = {
				r = 1,
				g = 0.25,
				b = 0.25,
			},
		},
		toggle = {
		},
		text = {
			enabled = false,
			thresh = 0,
			vpos = 100,
			hpos = 100,	
			fontFace = "Friz Quadrata TT",
			fontSize = 12,
			fontColor = {
				r = 1,
				g = 1,
				b = 1,
				a = 0.5,
			},
			fontOutline = "OUTLINE",
			vside = "RIGHT",
			hside = "BOTTOM",
		},
	},
	class = {
		-- for storing which spells triggered on which class
	},
};
local options = {
	name = "ExtraSpellAlert",
	type = 'group',
	args = {
		gen = {
			name = "General",
			type = 'group',
			args = {
				toggle = {
					name = L["Toggle Individual Spells"],
					type = 'group',
					order = 0,
					inline = true,
					args = {
						desc = {
							name = L["Spells will be added to this list once they have been gained at least once"],
							type = 'description',
							order = 0,
						},
						-- loaded dynamically
					},
				},
				stacks = {
					name = L["Animate Buff Charges"],
					type = 'group',
					order = 10,
					inline = true,
					args = {
						desc = {
							name = L["Shows additional animations to indicate when a buff has more than one charge left"],
							type = 'description',
							order = 0,
						},
						enabled = {
							name = L["Enabled"],
							type = 'toggle',
							order = 10,
							get = function(info) return core.db.profile.stacks.enabled end,
							set = function(info,v) core.db.profile.stacks.enabled = v end,
						},
					},
				},
				warn = {
					name = L["Low Buff Warning"],
					type = 'group',
					order = 20,
					inline = true,
					args = {
						desc = {
							name = L["Tints alerts when they are about to expire"],
							type = 'description',
							order = 0,
						},
						enabled = {
							name = L["Enabled"],
							type = 'toggle',
							order = 5,
							get = function(info) return core.db.profile.warn.enabled end,
							set = function(info,v) core.db.profile.warn.enabled = v end,
						},
						thresh = {
							name = L["Time Threshhold"],
							type = 'range',
							disabled = function() return not core.db.profile.warn.enabled end,
							order = 20,
							min = 1,
							max = 30,
							step = 1,
							get = function(info) return core.db.profile.warn.thresh end,
							set = function(info,v) core.db.profile.warn.thresh = v end,
						},
						color = {
							name = L["Color Tint"],
							type = 'color',
							disabled = function() return not core.db.profile.warn.enabled end,
							order = 10,
							hasAlpha = false,
							get = function(info) 
								return core.db.profile.warn.color.r, core.db.profile.warn.color.g, core.db.profile.warn.color.b, 1
							end,
							set = function(info,r,g,b) 
								core.db.profile.warn.color.r = r
								core.db.profile.warn.color.g = g
								core.db.profile.warn.color.b = b
							end,
						},
					},
				},
				text = {
					name = L["Timer Text"],
					type = 'group',
					order = 30,
					inline = true,
					args = {
						desc = {
							name = L["Shows a timer text on the overlay indicating exact time left"],
							type = 'description',
							order = 0,
						},
						enabled = {
							name = L["Enabled"],
							type = 'toggle',
							order = 5,
							get = function(info) return core.db.profile.text.enabled end,
							set = function(info,v) core.db.profile.text.enabled = v end,
						},
						thresh = {
							name = L["Time Threshhold"],
							type = 'range',
							desc = L["Time at which the text will appear on the overlays (0: Always)"],
							disabled = function() return not core.db.profile.text.enabled end,
							order = 10,
							min = 0,
							max = 30,
							step = 1,
							get = function(info) return core.db.profile.text.thresh end,
							set = function(info,v) core.db.profile.text.thresh = v end,
						},
						br15 = {
							name = '',
							type = 'description',
							order = 15,
						},
						font = {
							name = L["Font"],
							type = 'select',
							disabled = function() return not core.db.profile.text.enabled end,
							order = 20,
							values = {
								["Arial Narrow"] = "Arial Narrow",
								["Friz Quadrata TT"] = "Friz Quadrata TT",
								["Morpheus"] = "Morpheus",
								["Skurri"] = "Skurri",								
							},
							get = function(info) return core.db.profile.text.fontFace end,
							set = function(info,v) core.db.profile.text.fontFace = v; core:UpdateTextFrame(); end,
						},
						size = {
							name = L["Font Size"],
							type = 'range',
							disabled = function() return not core.db.profile.text.enabled end,
							order = 30,
							min = 6,
							max = 36,
							step = 1,
							get = function(info) return core.db.profile.text.fontSize end,
							set = function(info,v) core.db.profile.text.fontSize = v; core:UpdateTextFrame(); end,
						},
						color = {
							name = L["Font Color"],
							type = 'color',
							disabled = function() return not core.db.profile.text.enabled end,
							order = 40,
							hasAlpha = true,
							get = function(info) 
								return core.db.profile.text.fontColor.r, core.db.profile.text.fontColor.g, core.db.profile.text.fontColor.b, core.db.profile.text.fontColor.a
							end,
							set = function(info,r,g,b,a) 
								core.db.profile.text.fontColor.r = r;
								core.db.profile.text.fontColor.g = g;
								core.db.profile.text.fontColor.b = b;
								core.db.profile.text.fontColor.a = a; 
								core:UpdateTextFrame();
							end,
						},
						outline = {
							name = L["Font Outline"],
							type = 'select',
							disabled = function() return not core.db.profile.text.enabled end,
							order = 50,
							values = {
								["NONE"] = L["None"],
								["OUTLINE"] = L["Thin"],
								["THICKOUTLINE"] = L["Thick"],
							},
							get = function(info) return core.db.profile.text.fontOutline end,
							set = function(info,v) core.db.profile.text.fontOutline = v; core:UpdateTextFrame(); end,
						},
						br35 = {
							name = '',
							type = 'description',
							order = 55,
						},
						vposition = {
							name = L["Position (Vertical Overlays)"],
							type = 'range',
							desc = L["The position of the text on the vertical overlays (0: Top, 100: Bottom)"],
							disabled = function() return not core.db.profile.text.enabled end,
							order = 60,
							min = 0,
							max = 100,
							step = 1,
							get = function(info) return core.db.profile.text.vpos end,
							set = function(info,v) core.db.profile.text.vpos = v; core:UpdateTextPoints(); end,
						},
						hposition = {
							name = L["Position (Horizontal Overlays)"],
							type = 'range',
							desc = L["The position of the text on the horizontal overlays (0: Left, 100: Right)"],
							disabled = function() return not core.db.profile.text.enabled end,
							order = 70,
							min = 0,
							max = 100,
							step = 1,
							get = function(info) return core.db.profile.text.hpos end,
							set = function(info,v) core.db.profile.text.hpos = v; core:UpdateTextPoints(); end,
						},
						vside = {
							name = L["Mirrored Vertical Display"],
							type = 'select',
							desc = L["Which side of the vertical overlays to display the text on"],
							disabled = function() return not core.db.profile.text.enabled end,
							order = 80,
							values = {
								["LEFT"] = L["Left"],
								["RIGHT"] = L["Right"],
								["BOTH"] = L["Both"],
							},
							get = function(info) return core.db.profile.text.vside end,
							set = function(info,v) core.db.profile.text.vside = v; core:UpdateTextPoints(); end,
						},
						hside = {
							name = L["Mirrored Horizontal Display"],
							type = 'select',
							desc = L["Which side of the horizontal overlays to display the text on"],
							disabled = function() return not core.db.profile.text.enabled end,
							order = 90,
							values = {
								["TOP"] = L["Top"],
								["BOTTOM"] = L["Bottom"],
								["BOTH"] = L["Both"],
							},
							get = function(info) return core.db.profile.text.hside end,
							set = function(info,v) core.db.profile.text.hside = v; core:UpdateTextPoints(); end,
						},
					},
				},
			},
		},
	},
};

--[[ TODO
	Toggle specific auras from showing
	Tint red (as animation?) with low time
]]

local saoFrame = SpellActivationOverlayFrame

-- Blizzard locals
local sizeScale = 0.8;
local longSide = 256 * sizeScale;
local shortSide = 128 * sizeScale;

core.debug = 0;
--[===[@debug@
core.debug = 1; -- debug printing by level
--@end-debug@]===]
core.dbBuff = { }; -- populated by SPELL_ACTIVATION_OVERLAY_SHOW
core.buffStatus = {  -- populated by SPELL_ACTIVATION_OVERLAY_SHOW

	--[[[44544] = {			-- Fingers of Frost
		count = 0,
		redFlag = false,
	},]]
	
};
core.overlayList = { }; -- registry of all overlays
core.textFrames = { }; -- text frames


function core:BuildOptions()
	for i,v in pairs(self.db.profile.toggle) do
		if self.db.class[i] then
			-- check to see if this ID should be mapped
			options.args.gen.args.toggle.args[tostring(i)] = {
				name = self:GetSpellInfo(i),
				type = 'toggle',
				order = i,
				get = function(info) return core.db.profile.toggle[i] end,
				set = function(info,v) core.db.profile.toggle[i] = v end,
			};
		end
	end
end

function core:OnInitialize()
	self.db = LibStub("AceDB-3.0"):New("ExtraSpellAlertDB", defaults, "Default");
	-- populate table
	self:BuildOptions();
		
	self:RegisterChatCommand("esa", "SlashHandle");
	self:RegisterChatCommand("esalert", "SlashHandle");
	self:RegisterChatCommand("extraspellalert", "SlashHandle");
	
	options.args.profile = LibStub("AceDBOptions-3.0"):GetOptionsTable(self.db);
	LibStub("AceConfigRegistry-3.0"):RegisterOptionsTable("ExtraSpellAlert", options);
	local ACD = LibStub("AceConfigDialog-3.0");
	ACD:AddToBlizOptions("ExtraSpellAlert", "ExtraSpellAlert", nil, "gen");
	ACD:AddToBlizOptions("ExtraSpellAlert", options.args.profile.name, "ExtraSpellAlert", "profile");
end

function core:OnEnable()
	-- check if user has LSM
	LSM = LibStub:GetLibrary("LibSharedMedia-3.0", true);
	if (LSM and LibStub:GetLibrary("AceGUISharedMediaWidgets-1.0", true)) then
		options.args.gen.args.text.args.font.values = LSM:HashTable("font");
		options.args.gen.args.text.args.font.dialogControl = "LSM30_Font"
	end
	
	self:RegisterEvent("SPELL_ACTIVATION_OVERLAY_SHOW");
	self:RegisterEvent("SPELL_ACTIVATION_OVERLAY_HIDE");
	-- self:RegisterEvent("SPELL_ACTIVATION_OVERLAY_GLOW_SHOW", "test");
	-- self:RegisterEvent("SPELL_ACTIVATION_OVERLAY_GLOW_HIDE", "test");
	self:RegisterEvent("UNIT_AURA");
	self:UNIT_AURA(nil, "player");
	self:RawHook("SpellActivationOverlay_ShowAllOverlays", true);
	
	-- DEBUG
	-- SpellActivationOverlay_ShowAllOverlays(saoFrame, 4544, "TEXTURES\\SPELLACTIVATIONOVERLAYS\\FROZEN_FINGERS.BLP", "Top", 1, 255, 255, 255);
	-- local t = saoFrame:CreateTexture()
	-- t:SetAllPoints()
	-- t:SetTexture(0,0,0,1)
end

function core:test(...)
	for i=1, select('#', ...) do
		self:Print(i, select(i, ...), nil)
	end
end

function core:OnDisable()
	
end

function core:SlashHandle()
	LibStub("AceConfigDialog-3.0"):Open("ExtraSpellAlert")
end

function core:SPELL_ACTIVATION_OVERLAY_SHOW(_, spellID, texture, positions, scale, r, g, b)
	-- cache information
	if (not self.dbBuff[spellID]) then
		self.dbBuff[spellID] = {
			texture = texture,
			positions = positions,
			scale = scale,
			r = r,
			g = g,
			b = b,		
		};
		-- refire UNIT_AURA in case we simply didn't have a cache before
		self:UNIT_AURA(nil, "player");
	end
	
	-- create status
	if (not self.buffStatus[spellID]) then
		self.buffStatus[spellID] = {
			count = 0,
			redFlag = false,
		};
	end
	self.buffStatus[spellID].shown = true;
	
	-- check toggle cache
	if (self.db.profile.toggle[spellID] == nil) then
		self.db.profile.toggle[spellID] = true
		self:BuildOptions();
	end	
	if (not self.db.class[spellID]) then
		self.db.class[spellID] = true
		self:BuildOptions();		
	end
	
	-- schedule a check for low
	self:CheckTime(spellID);
	
	-- check for text
	if (self.db.profile.text.enabled) then
		self:DisplayText(spellID, positions);
	end
end

function core:SPELL_ACTIVATION_OVERLAY_HIDE(_, spellID)
	if (self.buffStatus[spellID]) then
		self.buffStatus[spellID].shown = false;
	end
end

local ABFlag = false
function core:UNIT_AURA(_, unit)
	-- temp test with AB
	-- if (not ABFlag and unit == "player" and UnitAura("player", "Arcane Brilliance")) then
		-- ABFlag = true
		-- self:DisplayText(1459, "BOTTOM");
	-- elseif (ABFlag and not UnitAura("player", "Arcane Brilliance")) then
		-- ABFlag = false
	-- end

	-- check if activations are enabled
	if (not GetCVarBool("displaySpellActivationOverlays")) then
		return
	end
	
	-- check if frame is enabled
	if (not saoFrame) then
		if (not SpellActivationOverlayFrame) then
			return;
		end
		saoFrame = SpellActivationOverlayFrame;
	end	
	
	if (unit == "player") then
		for i,v in pairs(self.buffStatus) do	
			-- check that we have db info and that we're not ignoring it
			if (self.dbBuff[i] and self.db.profile.toggle[i]) then-- TODO more .toggle checking in places
				local _, _, _, count, _, _, expires = self:UnitAura(self:GetSpellInfo(i));
				
				if (self.db.profile.stacks.enabled) then
					-- check if any stacks changed
					count = count or 0;
					-- self:Print("UNIT_AURA checking " .. i .. " with " .. (count or 0) .. " stacks (current: " .. v .. ")");
					if (v.count < count) then
						-- increase in stacks; max() prevents creating one at 1 stack
						for j=max(2, v.count+1),count do 
							self:ShowOverlay(j, i, self.dbBuff[i].texture, string.upper(self.dbBuff[i].positions), self.dbBuff[i].scale*(1+0.2*(j-1)), self.dbBuff[i].r, self.dbBuff[i].g, self.dbBuff[i].b, nil, nil, 1-0.2*(j-1));
						end
					elseif (v.count > count) then
						-- decrease in stacks; hide extras
						for j=count+1,v.count do
							self:HideOverlay(j, i);
						end
					end
					self.buffStatus[i].count = count;
				end
				
				if (self.db.profile.warn.enabled) then
					if (v.redFlag and expires and expires-GetTime()>self.db.profile.warn.thresh) then 
						-- buff was refreshed
						-- self:Debug(1, i, "Refreshed")
						self:CheckTime(i);
						v.redFlag = false;
						if (v.shown) then
							SpellActivationOverlay_ShowAllOverlays(saoFrame, i, self.dbBuff[i].texture, self.dbBuff[i].positions, self.dbBuff[i].scale, self.dbBuff[i].r, self.dbBuff[i].g, self.dbBuff[i].b);
						end
					end
				end
			end
		end
	end
end

-- functions similar to the blizzard functions in SpellActivationOverlay.lua
-- need to hardcode these myself because they only allow one animation per position ("TOP")

function core:ShowOverlay(index, spellID, texturePath, position, scale, r, g, b, vFlip, hFlip, alpha)
	-- self:Print(index, spellID, texturePath, position, scale, r, g, b, vFlip, hFlip);
	local overlay = self:GetUnusedOverlay();
	overlay.esaIndex = index;
	overlay.esaSpellID = spellID;
	self.overlayList[overlay] = true;
	
	overlay:SetFrameLevel(1);
	if (alpha and alpha < 1) then
		overlay.animIn:GetAnimations():SetChange(alpha);
		overlay.animIn:SetScript("OnFinished", function(anim)
			local overlay = anim:GetParent();
			overlay:SetAlpha(alpha);
			overlay.pulse:Play();
		end);
	end
	
	if (overlay.animOut:GetAnimations():HasScript("OnFinished")) then
		-- due to a FrameXML inconsistency on SpellActivationOverlay.xml:25 I need to traverse into the animation to set the script
		overlay.animOut:GetAnimations():SetScript("OnFinished", function(anim)
			self:OnFadeOutFinished(anim);
		end)
	else
		-- the inconsistency was fixed sometime
		overlay.animOut:SetScript("OnFinished")
	end
	
	
	-- blizzard
	overlay.spelID = spellID;
	overlay.position = position;
	
	overlay:ClearAllPoints();
	local texLeft, texRight, texTop, texBottom = 0, 1, 0, 1;
	if ( vFlip ) then
		texTop, texBottom = 1, 0;
	end
	if ( hFlip ) then
		texLeft, texRight = 1, 0;
	end
	overlay.texture:SetTexCoord(texLeft, texRight, texTop, texBottom);
	
	local width, height;
	if ( position == "CENTER" ) then
		width, height = longSide, longSide;
		overlay:SetPoint("CENTER", saoFrame, "CENTER", 0, 0);
	elseif ( position == "LEFT" ) then
		width, height = shortSide, longSide;
		overlay:SetPoint("RIGHT", saoFrame, "LEFT", 0, 0);
	elseif ( position == "RIGHT" ) then
		width, height = shortSide, longSide;
		overlay:SetPoint("LEFT", saoFrame, "RIGHT", 0, 0);
	elseif ( position == "TOP" ) then
		width, height = longSide, shortSide;
		overlay:SetPoint("BOTTOM", saoFrame, "TOP");
	elseif ( position == "BOTTOM" ) then
		width, height = longSide, shortSide;
		overlay:SetPoint("TOP", saoFrame, "BOTTOM");
	elseif ( position == "TOPRIGHT" ) then
		width, height = shortSide, shortSide;
		overlay:SetPoint("BOTTOMLEFT", saoFrame, "TOPRIGHT", 0, 0);
	elseif ( position == "TOPLEFT" ) then
		width, height = shortSide, shortSide;
		overlay:SetPoint("BOTTOMRIGHT", saoFrame, "TOPLEFT", 0, 0);
	elseif ( position == "BOTTOMRIGHT" ) then
		width, height = shortSide, shortSide;
		overlay:SetPoint("TOPLEFT", saoFrame, "BOTTOMRIGHT", 0, 0);
	elseif ( position == "BOTTOMLEFT" ) then
		width, height = shortSide, shortSide;
		overlay:SetPoint("TOPRIGHT", saoFrame, "BOTTOMLEFT", 0, 0);
	else
		--GMError("Unknown SpellActivationOverlay position: "..tostring(position));
		return;
	end
	
	overlay:SetSize(width * scale, height * scale);
	
	overlay.texture:SetTexture(texturePath);
	overlay.texture:SetVertexColor(r / 255, g / 255, b / 255);
	
	overlay.animOut:Stop();	--In case we're in the process of animating this out.
	PlaySoundKitID(23287);
	overlay:Show();
end 

function core:HideOverlay(index, spellID)
	for i,v in pairs(self.overlayList) do
		if (i.esaIndex == index and i.esaSpellID == spellID) then
			i.pulse:Pause();
			i.animOut:Play();
			self.overlayList[i] = false;
		end
	end
end

function core:GetUnusedOverlay()
	for i,v in pairs(self.overlayList) do
		if (not v) then
			return i;
		end
	end
	
	return self:CreateOverlay();
end

function core:CreateOverlay()
	return CreateFrame("Frame", nil, saoFrame, "SpellActivationOverlayTemplate");
end

function core:OnFadeOutFinished(anim)
	local overlay = anim:GetRegionParent();
	local overlayParent = overlay:GetParent();
	overlay.pulse:Stop();
	overlay:Hide();
end

-- End blizzard re-writes

function core:CheckTime(spellID)
	if (not self.db.profile.warn.enabled) then
		return
	end
	
	local expires = select(7, self:UnitAura(self:GetSpellInfo(spellID)));
	if (expires) then
		if ((expires-GetTime() < self.db.profile.warn.thresh+0.1) and 
			(self.buffStatus[spellID].shown)) then 
			-- re-show as red
			local colors = self.db.profile.warn.color;
			self.buffStatus[spellID].redFlag = true;
			SpellActivationOverlay_ShowAllOverlays(saoFrame, spellID, self.dbBuff[spellID].texture, self.dbBuff[spellID].positions, self.dbBuff[spellID].scale, colors.r*255, colors.g*255, colors.b*255);
		else
			-- spell was refreshed, reschedule
			self:ScheduleTimer(function()
				self:CheckTime(spellID);
			end, expires-GetTime()-self.db.profile.warn.thresh);
		end	
	end
end

function core:DisplayText(spellID, positions)
	local db = self.db.profile.text;
	positions = positions:upper();
	
	if (db.thresh > 0) then
		local expires = select(7, self:UnitAura(self:GetSpellInfo(spellID)));
		if ( expires ) then
			if (expires-GetTime() > db.thresh) then
				-- schedule display
				self:ScheduleTimer(function()
					self:DisplayText(spellID, positions);
				end, expires-GetTime()-db.thresh);
				return;
			end
		else
			return;
		end
	end
	
	-- actually display text
	
	-- fetch frame
	-- self:Print("DisplayText", spellID, positions);
	local texts = {self:GetTextFrames(positions)};
	-- set points
	if (saoFrame and saoFrame.overlaysInUse) then
		for i,v in ipairs(texts) do
			v.spellID = spellID;
			self:UpdateTextPoints(v, spellID);
		end
	end
	
	-- create updater
	local timer;
	timer = self:ScheduleRepeatingTimer(function()
		for i,v in ipairs(texts) do
			local expires = select(7, self:UnitAura(self:GetSpellInfo(spellID)));
			if ( expires ) then
				if ((db.thresh == 0 or expires-GetTime() < db.thresh) and v.refFrame:IsVisible()) then
					v.text:SetText(format("%.1f", max(0, expires-GetTime())));
				else
					-- hide on refresh
					v.text:SetText("");
				end
			else
				-- hide and cancel on expire
				v.text:SetText("");
				self:CancelTimer(timer, true);
				-- self:Print("CANCEL TIMER");
			end
		end
	end, 0.1);
end

function core:GetTextFrames(positions)
	local frame1, frame2;
	local db = self.db.profile.text;
	if (positions == "LEFT + RIGHT (FLIPPED)") then
		-- self:Print(db.vside);
		-- if double frame, check if we display both, and setup frame2
		if (db.vside == "BOTH") then
			-- both
			frame2 = self:GetTextFrame("RIGHT");
			positions = "LEFT";
		else
			positions = db.vside;
		end
	elseif (positions == "TOP + BOTTOM (FLIPPED)") then
		-- horizontal
		if (db.hside == "BOTH") then
			-- both
			frame2 = self:GetTextFrame("BOTTOM");
			positions = "TOP";
		else
			positions = db.hside;
		end
	end
	
	frame1 = self:GetTextFrame(positions);
	
	return frame1, frame2;	
end

function core:GetTextFrame(position)
	if (self.textFrames[position]) then
		return self.textFrames[position];
	end
	
	-- create frame
	local frame = CreateFrame("Frame", nil, saoFrame);
	frame.position = position;
	frame.text = frame:CreateFontString();
	-- frame.texture = frame:CreateTexture();
	-- frame.texture:SetAllPoints();
	-- frame.texture:SetTexture(0,0,0,0.5);
	frame:SetFrameLevel(1000);
	self:UpdateTextFrame(frame);
	self.textFrames[position] = frame;
	return self.textFrames[position];
end

function core:UpdateTextFrame(frame)
	-- update all frames
	if (not frame) then
		for i,v in pairs(self.textFrames) do
			self:UpdateTextFrame(v);
		end
		return
	end
	
	-- update single frame
	local db = self.db.profile.text
	frame:SetWidth(1);
	frame:SetHeight(1);
	frame.text:ClearAllPoints();
	frame.text:SetPoint("CENTER");
	frame.text:SetTextColor(db.fontColor.r, db.fontColor.g, db.fontColor.b, db.fontColor.a);
	local mode = db.fontOutline;
	if (mode == "NONE") then
		mode = nil
	end
	local font;
	if ( LSM ) then
		font = LSM:Fetch("font", db.fontFace);
	else 
		font = fontPaths[db.fontFace] or fontPaths["Friz Quadatra"];
	end
	frame.text:SetFont(font, db.fontSize, mode);
end

function core:UpdateTextPoints(frame, spellID)
	local db = self.db.profile.text;
	
	if (not frame) then
		for i,v in pairs(self.textFrames) do
			self:UpdateTextPoints(v, v.spellID);
		end
		return
	end
	
	if ( spellID ) then
		frame:ClearAllPoints();
		for j,w in pairs(saoFrame.overlaysInUse[spellID]) do
			-- w.texture:SetTexture(0,0,0,1);
			-- w.texture:SetAllPoints()
			-- self:Print("comparing", frame, "to", j, "(", frame.position:upper(), "==", w.position:upper(), ")")
			if (frame.position:upper() == w.position:upper()) then
				-- frame:SetPoint("CENTER", w, "CENTER");
				if (frame.position == "TOP" or frame.position == "BOTTOM") then
					frame.refFrame = w;
					frame:SetPoint("CENTER", w, "LEFT", db.hpos/100*w:GetWidth(), 0);
					-- self:Print("LEFT", db.hpos/100*w:GetWidth(), 0);
				else
					frame.refFrame = w;
					frame:SetPoint("CENTER", w, "TOP", 0, -db.vpos/100*w:GetHeight());
					-- self:Print("TOP", 0, -db.vpos/100*w:GetHeight());
				end
			end
		end
	end
end

function core:UnitAura(aura)
	for i=1,80 do
		local name = UnitBuff("player", i);
		
		if (not name) then
			return nil;
		elseif (name:find(aura)) then
			return UnitBuff("player", i);
		end
	end
	
	return nil;
end

function core:GetSpellInfo(id)
	if (overlayMap[id]) then
		return GetSpellInfo(overlayMap[id]);
	else 
		return GetSpellInfo(id);
	end
end

-- Blizzard function raw hook
function core:SpellActivationOverlay_ShowAllOverlays(...)
	local _, spellID = ...;
	if (spellID and self.db.profile.toggle[spellID] == false) then
		return false
	end
	
	return self.hooks["SpellActivationOverlay_ShowAllOverlays"](...);
end

function core:Debug(level, ...)
	if (type(level) ~= "number") then
		self:Debug(1, level, ...);
		return;
	end
	if self.debug >= level then 
		self:Print(...);
	end
end